diff --git a/examples/bbdev_app/meson.build b/examples/bbdev_app/meson.build
index 8e06a8a235..df8ee6842c 100644
--- a/examples/bbdev_app/meson.build
+++ b/examples/bbdev_app/meson.build
@@ -9,5 +9,5 @@
 deps += 'bbdev'
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/bond/meson.build b/examples/bond/meson.build
index 69382ffcd2..eba94bfe8a 100644
--- a/examples/bond/meson.build
+++ b/examples/bond/meson.build
@@ -9,5 +9,5 @@
 deps += 'net_bond'
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/cmdline/meson.build b/examples/cmdline/meson.build
index 7de0f16251..04b2995aa6 100644
--- a/examples/cmdline/meson.build
+++ b/examples/cmdline/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'commands.c', 'main.c', 'parse_obj_list.c'
+    'commands.c', 'main.c', 'parse_obj_list.c'
 )
diff --git a/examples/distributor/meson.build b/examples/distributor/meson.build
index d8dbc235fb..52e91ee784 100644
--- a/examples/distributor/meson.build
+++ b/examples/distributor/meson.build
@@ -9,11 +9,11 @@
 # require the power library
 build = dpdk_conf.has('RTE_LIB_POWER')
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 allow_experimental_apis = true
 deps += ['distributor', 'power']
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/ethtool/meson.build b/examples/ethtool/meson.build
index 4d08bc4c57..1b57daaff1 100644
--- a/examples/ethtool/meson.build
+++ b/examples/ethtool/meson.build
@@ -8,17 +8,17 @@
 
 build = is_linux
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 sources = files('lib/rte_ethtool.c',
-	'ethtool-app/ethapp.c',
-	'ethtool-app/main.c')
+    'ethtool-app/ethapp.c',
+    'ethtool-app/main.c')
 includes = include_directories('lib', 'ethtool-app')
 
 deps += 'bus_pci'
 if dpdk_conf.has('RTE_NET_IXGBE')
-	deps += 'net_ixgbe'
+    deps += 'net_ixgbe'
 endif
 
 allow_experimental_apis = true
diff --git a/examples/eventdev_pipeline/meson.build b/examples/eventdev_pipeline/meson.build
index 1dfeba0d3f..ca983aa056 100644
--- a/examples/eventdev_pipeline/meson.build
+++ b/examples/eventdev_pipeline/meson.build
@@ -9,7 +9,7 @@
 allow_experimental_apis = true
 deps += 'eventdev'
 sources = files(
-	'main.c',
-	'pipeline_worker_generic.c',
-	'pipeline_worker_tx.c'
+    'main.c',
+    'pipeline_worker_generic.c',
+    'pipeline_worker_tx.c'
 )
diff --git a/examples/fips_validation/meson.build b/examples/fips_validation/meson.build
index e2745d2786..6cdffc82f6 100644
--- a/examples/fips_validation/meson.build
+++ b/examples/fips_validation/meson.build
@@ -9,15 +9,15 @@
 deps += ['cryptodev']
 allow_experimental_apis = true
 sources = files(
-	'fips_validation_aes.c',
-	'fips_validation.c',
-	'fips_validation_hmac.c',
-	'fips_validation_tdes.c',
-	'fips_validation_gcm.c',
-	'fips_validation_cmac.c',
-	'fips_validation_ccm.c',
-	'fips_validation_sha.c',
-	'fips_validation_xts.c',
-	'fips_dev_self_test.c',
-	'main.c'
+    'fips_validation_aes.c',
+    'fips_validation.c',
+    'fips_validation_hmac.c',
+    'fips_validation_tdes.c',
+    'fips_validation_gcm.c',
+    'fips_validation_cmac.c',
+    'fips_validation_ccm.c',
+    'fips_validation_sha.c',
+    'fips_validation_xts.c',
+    'fips_dev_self_test.c',
+    'main.c'
 )
diff --git a/examples/flow_classify/meson.build b/examples/flow_classify/meson.build
index 56472e6819..c2364aa2f4 100644
--- a/examples/flow_classify/meson.build
+++ b/examples/flow_classify/meson.build
@@ -9,5 +9,5 @@
 deps += 'flow_classify'
 allow_experimental_apis = true
 sources = files(
-	'flow_classify.c'
+    'flow_classify.c'
 )
diff --git a/examples/flow_filtering/meson.build b/examples/flow_filtering/meson.build
index 6f5d1b08a9..cde1ef8ecd 100644
--- a/examples/flow_filtering/meson.build
+++ b/examples/flow_filtering/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'main.c',
+    'main.c',
 )
diff --git a/examples/helloworld/meson.build b/examples/helloworld/meson.build
index 2b0a250361..0b893d2144 100644
--- a/examples/helloworld/meson.build
+++ b/examples/helloworld/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/ioat/meson.build b/examples/ioat/meson.build
index e348196ba3..24057d9c1c 100644
--- a/examples/ioat/meson.build
+++ b/examples/ioat/meson.build
@@ -9,11 +9,11 @@
 allow_experimental_apis = true
 build = dpdk_conf.has('RTE_RAW_IOAT')
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 deps += ['raw_ioat']
 
 sources = files(
-	'ioatfwd.c'
+    'ioatfwd.c'
 )
diff --git a/examples/ip_fragmentation/meson.build b/examples/ip_fragmentation/meson.build
index 1230db4776..336a1fcb70 100644
--- a/examples/ip_fragmentation/meson.build
+++ b/examples/ip_fragmentation/meson.build
@@ -9,5 +9,5 @@
 allow_experimental_apis = true
 deps +=  ['ip_frag', 'lpm']
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/ip_pipeline/meson.build b/examples/ip_pipeline/meson.build
index 945e28b58b..23c785cb47 100644
--- a/examples/ip_pipeline/meson.build
+++ b/examples/ip_pipeline/meson.build
@@ -8,24 +8,24 @@
 
 build = cc.has_header('sys/epoll.h')
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 deps += ['pipeline', 'bus_pci']
 allow_experimental_apis = true
 sources = files(
-	'action.c',
-	'cli.c',
-	'conn.c',
-	'kni.c',
-	'link.c',
-	'main.c',
-	'mempool.c',
-	'parser.c',
-	'pipeline.c',
-	'swq.c',
-	'tap.c',
-	'thread.c',
-	'tmgr.c',
-	'cryptodev.c'
+    'action.c',
+    'cli.c',
+    'conn.c',
+    'kni.c',
+    'link.c',
+    'main.c',
+    'mempool.c',
+    'parser.c',
+    'pipeline.c',
+    'swq.c',
+    'tap.c',
+    'thread.c',
+    'tmgr.c',
+    'cryptodev.c'
 )
diff --git a/examples/ip_reassembly/meson.build b/examples/ip_reassembly/meson.build
index 517bd4e19a..bf5eab6f0a 100644
--- a/examples/ip_reassembly/meson.build
+++ b/examples/ip_reassembly/meson.build
@@ -9,5 +9,5 @@
 allow_experimental_apis = true
 deps += ['lpm', 'ip_frag']
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/ipsec-secgw/meson.build b/examples/ipsec-secgw/meson.build
index d0373dab53..298a32bf64 100644
--- a/examples/ipsec-secgw/meson.build
+++ b/examples/ipsec-secgw/meson.build
@@ -9,17 +9,17 @@
 deps += ['security', 'lpm', 'acl', 'hash', 'ip_frag', 'ipsec', 'eventdev']
 allow_experimental_apis = true
 sources = files(
-	'esp.c',
-	'event_helper.c',
-	'flow.c',
-	'ipsec.c',
-	'ipsec_process.c',
-	'ipsec-secgw.c',
-	'ipsec_worker.c',
-	'parser.c',
-	'rt.c',
-	'sa.c',
-	'sad.c',
-	'sp4.c',
-	'sp6.c'
+    'esp.c',
+    'event_helper.c',
+    'flow.c',
+    'ipsec.c',
+    'ipsec_process.c',
+    'ipsec-secgw.c',
+    'ipsec_worker.c',
+    'parser.c',
+    'rt.c',
+    'sa.c',
+    'sad.c',
+    'sp4.c',
+    'sp6.c'
 )
diff --git a/examples/ipv4_multicast/meson.build b/examples/ipv4_multicast/meson.build
index 7dc13fb8fc..a3f6673046 100644
--- a/examples/ipv4_multicast/meson.build
+++ b/examples/ipv4_multicast/meson.build
@@ -9,5 +9,5 @@
 allow_experimental_apis = true
 deps += 'hash'
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/kni/meson.build b/examples/kni/meson.build
index e119eebabb..e782f458d0 100644
--- a/examples/kni/meson.build
+++ b/examples/kni/meson.build
@@ -9,11 +9,11 @@
 # this app can be built if-and-only-if KNI library is buildable
 build = dpdk_conf.has('RTE_LIB_KNI')
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 deps += ['kni', 'bus_pci']
 sources = files(
-	'main.c'
+    'main.c'
 )
 allow_experimental_apis = true
diff --git a/examples/l2fwd-cat/meson.build b/examples/l2fwd-cat/meson.build
index 60169bcbda..3b48a0972a 100644
--- a/examples/l2fwd-cat/meson.build
+++ b/examples/l2fwd-cat/meson.build
@@ -9,12 +9,12 @@
 pqos = cc.find_library('pqos', required: false)
 build = pqos.found()
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 ext_deps += pqos
 allow_experimental_apis = true
 cflags += '-I/usr/local/include' # assume pqos lib installed in /usr/local
 sources = files(
-	'cat.c', 'l2fwd-cat.c'
+    'cat.c', 'l2fwd-cat.c'
 )
diff --git a/examples/l2fwd-crypto/meson.build b/examples/l2fwd-crypto/meson.build
index 1813f015b2..8fe4c451dc 100644
--- a/examples/l2fwd-crypto/meson.build
+++ b/examples/l2fwd-crypto/meson.build
@@ -8,9 +8,9 @@
 
 deps += 'cryptodev'
 if dpdk_conf.has('RTE_CRYPTO_SCHEDULER')
-	deps += 'crypto_scheduler'
+    deps += 'crypto_scheduler'
 endif
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/l2fwd-event/meson.build b/examples/l2fwd-event/meson.build
index 4a546eaf81..2388f59e91 100644
--- a/examples/l2fwd-event/meson.build
+++ b/examples/l2fwd-event/meson.build
@@ -10,10 +10,10 @@
 allow_experimental_apis = true
 deps += 'eventdev'
 sources = files(
-	'main.c',
-	'l2fwd_poll.c',
-	'l2fwd_common.c',
-	'l2fwd_event.c',
-	'l2fwd_event_internal_port.c',
-	'l2fwd_event_generic.c'
+    'main.c',
+    'l2fwd_poll.c',
+    'l2fwd_common.c',
+    'l2fwd_event.c',
+    'l2fwd_event_internal_port.c',
+    'l2fwd_event_generic.c'
 )
diff --git a/examples/l2fwd-jobstats/meson.build b/examples/l2fwd-jobstats/meson.build
index 72273736b6..a42914025f 100644
--- a/examples/l2fwd-jobstats/meson.build
+++ b/examples/l2fwd-jobstats/meson.build
@@ -9,5 +9,5 @@
 allow_experimental_apis = true
 deps += ['jobstats', 'timer']
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/l2fwd-keepalive/meson.build b/examples/l2fwd-keepalive/meson.build
index a56d679675..3ca5b6fd9c 100644
--- a/examples/l2fwd-keepalive/meson.build
+++ b/examples/l2fwd-keepalive/meson.build
@@ -9,12 +9,12 @@
 allow_experimental_apis = true
 librt = cc.find_library('rt', required: false)
 if not librt.found()
-	build = false
-	subdir_done()
+    build = false
+    subdir_done()
 endif
 
 ext_deps += librt
 deps += 'timer'
 sources = files(
-	'main.c', 'shm.c'
+    'main.c', 'shm.c'
 )
diff --git a/examples/l2fwd/meson.build b/examples/l2fwd/meson.build
index 50d88caa0a..f50bf0927b 100644
--- a/examples/l2fwd/meson.build
+++ b/examples/l2fwd/meson.build
@@ -9,5 +9,5 @@
 # Enable experimental API flag as l2fwd uses rte_ethdev_set_ptype API
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/l3fwd-acl/meson.build b/examples/l3fwd-acl/meson.build
index 6fa468b3aa..b0b42afcba 100644
--- a/examples/l3fwd-acl/meson.build
+++ b/examples/l3fwd-acl/meson.build
@@ -9,5 +9,5 @@
 allow_experimental_apis = true
 deps += ['acl', 'lpm', 'hash']
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/l3fwd-graph/meson.build b/examples/l3fwd-graph/meson.build
index a816bd8903..2550bdea7c 100644
--- a/examples/l3fwd-graph/meson.build
+++ b/examples/l3fwd-graph/meson.build
@@ -8,6 +8,6 @@
 
 deps += ['graph', 'eal', 'lpm', 'ethdev', 'node' ]
 sources = files(
-	'main.c'
+    'main.c'
 )
 allow_experimental_apis = true
diff --git a/examples/l3fwd-power/meson.build b/examples/l3fwd-power/meson.build
index eb8aef306a..b4cb93c9c4 100644
--- a/examples/l3fwd-power/meson.build
+++ b/examples/l3fwd-power/meson.build
@@ -14,5 +14,5 @@ endif
 allow_experimental_apis = true
 deps += ['power', 'timer', 'lpm', 'hash', 'metrics', 'telemetry']
 sources = files(
-	'main.c', 'perf_core.c'
+    'main.c', 'perf_core.c'
 )
diff --git a/examples/l3fwd/meson.build b/examples/l3fwd/meson.build
index 7d72b1b365..05b2ba45f0 100644
--- a/examples/l3fwd/meson.build
+++ b/examples/l3fwd/meson.build
@@ -9,6 +9,6 @@
 allow_experimental_apis = true
 deps += ['hash', 'lpm', 'eventdev']
 sources = files(
-	'l3fwd_em.c', 'l3fwd_lpm.c', 'l3fwd_event.c',
-	'l3fwd_event_internal_port.c', 'l3fwd_event_generic.c', 'main.c'
+    'l3fwd_em.c', 'l3fwd_lpm.c', 'l3fwd_event.c',
+    'l3fwd_event_internal_port.c', 'l3fwd_event_generic.c', 'main.c'
 )
diff --git a/examples/link_status_interrupt/meson.build b/examples/link_status_interrupt/meson.build
index 2b0a250361..0b893d2144 100644
--- a/examples/link_status_interrupt/meson.build
+++ b/examples/link_status_interrupt/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/multi_process/client_server_mp/mp_client/meson.build b/examples/multi_process/client_server_mp/mp_client/meson.build
index 69c3d3bfbe..e9edb216ee 100644
--- a/examples/multi_process/client_server_mp/mp_client/meson.build
+++ b/examples/multi_process/client_server_mp/mp_client/meson.build
@@ -10,5 +10,5 @@ includes += include_directories('../shared')
 
 allow_experimental_apis = true
 sources = files(
-	'client.c'
+    'client.c'
 )
diff --git a/examples/multi_process/client_server_mp/mp_server/meson.build b/examples/multi_process/client_server_mp/mp_server/meson.build
index 0ef6424f4b..a166a0fb97 100644
--- a/examples/multi_process/client_server_mp/mp_server/meson.build
+++ b/examples/multi_process/client_server_mp/mp_server/meson.build
@@ -10,5 +10,5 @@ includes += include_directories('../shared')
 
 allow_experimental_apis = true
 sources = files(
-	'args.c', 'init.c', 'main.c'
+    'args.c', 'init.c', 'main.c'
 )
diff --git a/examples/multi_process/hotplug_mp/meson.build b/examples/multi_process/hotplug_mp/meson.build
index f82f4d48a2..821e6d6bb2 100644
--- a/examples/multi_process/hotplug_mp/meson.build
+++ b/examples/multi_process/hotplug_mp/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'commands.c', 'main.c'
+    'commands.c', 'main.c'
 )
diff --git a/examples/multi_process/simple_mp/meson.build b/examples/multi_process/simple_mp/meson.build
index cb02c65a69..6b4ee638d3 100644
--- a/examples/multi_process/simple_mp/meson.build
+++ b/examples/multi_process/simple_mp/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'mp_commands.c', 'main.c'
+    'mp_commands.c', 'main.c'
 )
diff --git a/examples/multi_process/symmetric_mp/meson.build b/examples/multi_process/symmetric_mp/meson.build
index 14167825b0..201558f89c 100644
--- a/examples/multi_process/symmetric_mp/meson.build
+++ b/examples/multi_process/symmetric_mp/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/ntb/meson.build b/examples/ntb/meson.build
index 02be9fc80d..6010458e9d 100644
--- a/examples/ntb/meson.build
+++ b/examples/ntb/meson.build
@@ -8,15 +8,15 @@
 
 allow_experimental_apis = true
 if not is_linux
-	build = false
-	subdir_done()
+    build = false
+    subdir_done()
 endif
 
 deps += 'rawdev'
 cflags += ['-D_FILE_OFFSET_BITS=64']
 sources = files(
-	'ntb_fwd.c'
+    'ntb_fwd.c'
 )
 if dpdk_conf.has('RTE_RAW_NTB')
-	deps += 'raw_ntb'
+    deps += 'raw_ntb'
 endif
diff --git a/examples/packet_ordering/meson.build b/examples/packet_ordering/meson.build
index b381959145..99dd1bb76f 100644
--- a/examples/packet_ordering/meson.build
+++ b/examples/packet_ordering/meson.build
@@ -9,5 +9,5 @@
 allow_experimental_apis = true
 deps += 'reorder'
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/performance-thread/l3fwd-thread/meson.build b/examples/performance-thread/l3fwd-thread/meson.build
index 4858b201e4..58d4e96a45 100644
--- a/examples/performance-thread/l3fwd-thread/meson.build
+++ b/examples/performance-thread/l3fwd-thread/meson.build
@@ -8,7 +8,7 @@
 
 build = dpdk_conf.has('RTE_ARCH_X86_64')
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 deps += ['timer', 'lpm']
@@ -16,17 +16,17 @@ allow_experimental_apis = true
 
 # get the performance thread (pt) architecture subdir
 if dpdk_conf.has('RTE_ARCH_ARM64')
-	pt_arch_dir = '../common/arch/arm64'
+    pt_arch_dir = '../common/arch/arm64'
 else
-	pt_arch_dir = '../common/arch/x86'
+    pt_arch_dir = '../common/arch/x86'
 endif
 sources += files('main.c',
-	'../common/lthread.c',
-	'../common/lthread_cond.c',
-	'../common/lthread_diag.c',
-	'../common/lthread_mutex.c',
-	'../common/lthread_sched.c',
-	'../common/lthread_tls.c',
-	pt_arch_dir + '/ctx.c')
+    '../common/lthread.c',
+    '../common/lthread_cond.c',
+    '../common/lthread_diag.c',
+    '../common/lthread_mutex.c',
+    '../common/lthread_sched.c',
+    '../common/lthread_tls.c',
+    pt_arch_dir + '/ctx.c')
 
 includes += include_directories('../common', pt_arch_dir)
diff --git a/examples/performance-thread/pthread_shim/meson.build b/examples/performance-thread/pthread_shim/meson.build
index d499799307..866e6c94e8 100644
--- a/examples/performance-thread/pthread_shim/meson.build
+++ b/examples/performance-thread/pthread_shim/meson.build
@@ -8,7 +8,7 @@
 
 build = dpdk_conf.has('RTE_ARCH_X86_64') or dpdk_conf.has('RTE_ARCH_ARM64')
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 deps += ['timer']
@@ -16,18 +16,18 @@ allow_experimental_apis = true
 
 # get the performance thread (pt) architecture subdir
 if dpdk_conf.has('RTE_ARCH_ARM64')
-	pt_arch_dir = '../common/arch/arm64'
+    pt_arch_dir = '../common/arch/arm64'
 else
-	pt_arch_dir = '../common/arch/x86'
+    pt_arch_dir = '../common/arch/x86'
 endif
 sources += files('main.c',
-	'pthread_shim.c',
-	'../common/lthread.c',
-	'../common/lthread_cond.c',
-	'../common/lthread_diag.c',
-	'../common/lthread_mutex.c',
-	'../common/lthread_sched.c',
-	'../common/lthread_tls.c',
-	pt_arch_dir + '/ctx.c')
+    'pthread_shim.c',
+    '../common/lthread.c',
+    '../common/lthread_cond.c',
+    '../common/lthread_diag.c',
+    '../common/lthread_mutex.c',
+    '../common/lthread_sched.c',
+    '../common/lthread_tls.c',
+    pt_arch_dir + '/ctx.c')
 
 includes += include_directories('../common', pt_arch_dir)
diff --git a/examples/pipeline/meson.build b/examples/pipeline/meson.build
index 4f5925d7cf..02c0944f5a 100644
--- a/examples/pipeline/meson.build
+++ b/examples/pipeline/meson.build
@@ -8,15 +8,15 @@
 
 build = cc.has_header('sys/epoll.h')
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 deps += ['pipeline', 'bus_pci']
 allow_experimental_apis = true
 sources = files(
-	'cli.c',
-	'conn.c',
-	'main.c',
-	'obj.c',
-	'thread.c',
+    'cli.c',
+    'conn.c',
+    'main.c',
+    'obj.c',
+    'thread.c',
 )
diff --git a/examples/ptpclient/meson.build b/examples/ptpclient/meson.build
index d4171a2183..abe1961959 100644
--- a/examples/ptpclient/meson.build
+++ b/examples/ptpclient/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'ptpclient.c'
+    'ptpclient.c'
 )
diff --git a/examples/qos_meter/meson.build b/examples/qos_meter/meson.build
index 2f9ab13afd..43fff9cada 100644
--- a/examples/qos_meter/meson.build
+++ b/examples/qos_meter/meson.build
@@ -9,5 +9,5 @@
 allow_experimental_apis = true
 deps += 'meter'
 sources = files(
-	'main.c', 'rte_policer.c'
+    'main.c', 'rte_policer.c'
 )
diff --git a/examples/qos_sched/meson.build b/examples/qos_sched/meson.build
index ba59d3c9e5..ef8e40739c 100644
--- a/examples/qos_sched/meson.build
+++ b/examples/qos_sched/meson.build
@@ -9,6 +9,6 @@
 allow_experimental_apis = true
 deps += ['sched', 'cfgfile']
 sources = files(
-	'app_thread.c', 'args.c', 'cfg_file.c', 'cmdline.c',
-	'init.c', 'main.c', 'stats.c'
+    'app_thread.c', 'args.c', 'cfg_file.c', 'cmdline.c',
+    'init.c', 'main.c', 'stats.c'
 )
diff --git a/examples/rxtx_callbacks/meson.build b/examples/rxtx_callbacks/meson.build
index a7bf12dd3a..12b41f59f1 100644
--- a/examples/rxtx_callbacks/meson.build
+++ b/examples/rxtx_callbacks/meson.build
@@ -10,5 +10,5 @@
 allow_experimental_apis = true
 
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/service_cores/meson.build b/examples/service_cores/meson.build
index 2b0a250361..0b893d2144 100644
--- a/examples/service_cores/meson.build
+++ b/examples/service_cores/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/skeleton/meson.build b/examples/skeleton/meson.build
index ef46b187e7..7e0b7d1122 100644
--- a/examples/skeleton/meson.build
+++ b/examples/skeleton/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'basicfwd.c'
+    'basicfwd.c'
 )
diff --git a/examples/timer/meson.build b/examples/timer/meson.build
index 87c21a8679..e03b692667 100644
--- a/examples/timer/meson.build
+++ b/examples/timer/meson.build
@@ -9,5 +9,5 @@
 allow_experimental_apis = true
 deps += 'timer'
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/vdpa/meson.build b/examples/vdpa/meson.build
index 26f6089c92..3ddbbc1265 100644
--- a/examples/vdpa/meson.build
+++ b/examples/vdpa/meson.build
@@ -7,12 +7,12 @@
 # DPDK instance, use 'make'
 
 if not is_linux
-	build = false
-	subdir_done()
+    build = false
+    subdir_done()
 endif
 
 deps += 'vhost'
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/vhost/meson.build b/examples/vhost/meson.build
index 9d9947c585..41ab9cfb1f 100644
--- a/examples/vhost/meson.build
+++ b/examples/vhost/meson.build
@@ -7,17 +7,17 @@
 # DPDK instance, use 'make'
 
 if not is_linux
-	build = false
-	subdir_done()
+    build = false
+    subdir_done()
 endif
 
 deps += 'vhost'
 allow_experimental_apis = true
 sources = files(
-	'main.c', 'virtio_net.c'
+    'main.c', 'virtio_net.c'
 )
 
 if dpdk_conf.has('RTE_RAW_IOAT')
-	deps += 'raw_ioat'
-	sources += files('ioat.c')
+    deps += 'raw_ioat'
+    sources += files('ioat.c')
 endif
diff --git a/examples/vhost_blk/meson.build b/examples/vhost_blk/meson.build
index 354ba05848..ad61577693 100644
--- a/examples/vhost_blk/meson.build
+++ b/examples/vhost_blk/meson.build
@@ -7,17 +7,17 @@
 # DPDK instance, use 'make'
 
 if not is_linux
-	build = false
-	subdir_done()
+    build = false
+    subdir_done()
 endif
 
 if not cc.has_header('linux/virtio_blk.h')
-	build = false
-	subdir_done()
+    build = false
+    subdir_done()
 endif
 
 deps += 'vhost'
 allow_experimental_apis = true
 sources = files(
-	'blk.c', 'vhost_blk.c', 'vhost_blk_compat.c'
+    'blk.c', 'vhost_blk.c', 'vhost_blk_compat.c'
 )
diff --git a/examples/vhost_crypto/meson.build b/examples/vhost_crypto/meson.build
index 403f210983..d379ba0787 100644
--- a/examples/vhost_crypto/meson.build
+++ b/examples/vhost_crypto/meson.build
@@ -8,11 +8,11 @@
 
 build = dpdk_conf.has('RTE_LIB_VHOST')
 if not build
-	subdir_done()
+    subdir_done()
 endif
 
 allow_experimental_apis = true
 deps += ['vhost', 'cryptodev']
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/vm_power_manager/guest_cli/meson.build b/examples/vm_power_manager/guest_cli/meson.build
index cd95266018..6ac09ef025 100644
--- a/examples/vm_power_manager/guest_cli/meson.build
+++ b/examples/vm_power_manager/guest_cli/meson.build
@@ -14,7 +14,7 @@ endif
 deps += ['power']
 
 sources = files(
-	'main.c', 'parse.c', 'vm_power_cli_guest.c'
+    'main.c', 'parse.c', 'vm_power_cli_guest.c'
 )
 
 allow_experimental_apis = true
diff --git a/examples/vm_power_manager/meson.build b/examples/vm_power_manager/meson.build
index 637bd23235..67e72a222b 100644
--- a/examples/vm_power_manager/meson.build
+++ b/examples/vm_power_manager/meson.build
@@ -7,34 +7,34 @@
 # DPDK instance, use 'make'
 
 if not dpdk_conf.has('RTE_LIB_POWER')
-	build = false
-	subdir_done()
+    build = false
+    subdir_done()
 endif
 
 deps += ['power']
 
 if dpdk_conf.has('RTE_NET_BNXT')
-	deps += ['net_bnxt']
+    deps += ['net_bnxt']
 endif
 
 if dpdk_conf.has('RTE_NET_I40E')
-	deps += ['net_i40e']
+    deps += ['net_i40e']
 endif
 
 if dpdk_conf.has('RTE_NET_IXGBE')
-	deps += ['net_ixgbe']
+    deps += ['net_ixgbe']
 endif
 
 allow_experimental_apis = true
 sources = files(
-	'channel_manager.c', 'channel_monitor.c', 'main.c', 'parse.c', 'power_manager.c', 'vm_power_cli.c'
+    'channel_manager.c', 'channel_monitor.c', 'main.c', 'parse.c', 'power_manager.c', 'vm_power_cli.c'
 )
 
 # If we're on X86, pull in the x86 code for the branch monitor algo.
 if dpdk_conf.has('RTE_ARCH_X86_64')
-	sources += files('oob_monitor_x86.c')
+    sources += files('oob_monitor_x86.c')
 else
-	sources += files('oob_monitor_nop.c')
+    sources += files('oob_monitor_nop.c')
 endif
 
 opt_dep = cc.find_library('virt', required : false)
@@ -43,6 +43,6 @@ ext_deps += opt_dep
 
 opt_dep = dependency('jansson', required : false, method: 'pkg-config')
 if opt_dep.found()
-	ext_deps += opt_dep
-	cflags += '-DUSE_JANSSON'
+    ext_deps += opt_dep
+    cflags += '-DUSE_JANSSON'
 endif
diff --git a/examples/vmdq/meson.build b/examples/vmdq/meson.build
index 2b0a250361..0b893d2144 100644
--- a/examples/vmdq/meson.build
+++ b/examples/vmdq/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )
diff --git a/examples/vmdq_dcb/meson.build b/examples/vmdq_dcb/meson.build
index 2b0a250361..0b893d2144 100644
--- a/examples/vmdq_dcb/meson.build
+++ b/examples/vmdq_dcb/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-	'main.c'
+    'main.c'
 )